#!/usr/bin/perl

# ************************** Get time **********************************
sub timed
{
      my $setup=$_[0];
      my $named=$_[1];

      my $date = $setup ->{'date'};
      my $time = $setup ->{'time'};
      my $weekd = $setup ->{'wday'};

      my($sec,$min,$hours,$mday,$month,$year,$wday,$yday,$isdst)=localtime(time+(3600*$setup->{'timeoffset'}));

      my $mon=$month;
      $month=$month+1;

      my $hr = $hours;

      if ($min < 10) {$min="0$min";}
      if ($hours < 10) {$hours="0$hours";}
      if ($sec < 10) {$sec="0$sec";}
      if ($mday < 10) {$mday="0$mday";}
      if ($month <10) {$month="0$month";}
      my @days = ("$named->{7}","$named->{1}","$named->{2}","$named->{3}","$named->{4}","$named->{5}","$named->{6}");
      my @months = ("$named->{8}","$named->{9}","$named->{10}","$named->{11}","$named->{12}","$named->{13}",
                  "$named->{14}","$named->{15}","$named->{16}","$named->{17}","$named->{18}","$named->{19}");

      my @days_s = ("$named->{26}","$named->{20}","$named->{21}","$named->{22}","$named->{23}","$named->{24}","$named->{25}");
      my @months_s = ("$named->{27}","$named->{28}","$named->{29}","$named->{30}","$named->{31}","$named->{32}",
                  "$named->{33}","$named->{34}","$named->{35}","$named->{36}","$named->{37}","$named->{38}");


      my $ap = "Am";

      if ($hr > 12){
           $hr-=12;
           $ap = "Pm";
      }

      my $weekdf=$days[$wday];
      my $weekds=$days_s[$wday];

      $year = 2000+($year-100);

      my $yyyy = $year;
      my $yy = $year;
         $yy = substr($yy,2);

      my $MO = $months[$mon];
      my $Mo = $months_s[$mon];
# ====== Date
         $date =~ s/\$yyyy\$/$yyyy/;
         $date =~ s/\$yy\$/$yy/;
         $date =~ s/\$MO\$/$MO/;
         $date =~ s/\$Mo\$/$Mo/;
         $date =~ s/\$mo\$/$month/;
         $date =~ s/\$dd\$/$mday/;
# ====== Time
         $time =~ s/\$HH\$/$hours/;
         $time =~ s/\$hh\$/$hr/;
         $time =~ s/\$AP\$/$ap/;
         $time =~ s/\$mm\$/$min/;
         $time =~ s/\$ss\$/$sec/;
# ====== Wday
         $weekd =~ s/\$WD\$/$weekdf/;
         $weekd =~ s/\$wd\$/$weekds/;

      return ($date,$time,$weekd);

}
# ****************** SUB symbols2codes *********************

sub symbols2codes
{
      my $text=$_[0];
      my $method =$_[1];
      my %symbols=();
      if ($method eq 'all' or $method == 1){
            %symbols=('\!'        =>        '&#33;',
                        '\"'        =>        '&#34;',
                        '\#'        =>        '&#35;',
                        '\$'        =>        '&#36;',
                        '\%'        =>        '&#37;',
                        '\&'        =>        '&#38;',
                        '\''        =>        '&#39;',
                        '\('        =>        '&#40;',
                        '\)'        =>        '&#41;',
                        '\*'        =>        '&#42;',
                        '\+'        =>        '&#43;',
                        '\/'        =>        '&#47;',
                        '\<'        =>        '&#60;',
                        '\='        =>        '&#61;',
                        '\>'        =>        '&#62;',
                        '\?'        =>        '&#63;',
                        '\@'        =>        '&#64;',
                        '\['        =>        '&#91;',
                        '\]'        =>        '&#93;',
                        '\^'        =>        '&#94;',
                        '\`'        =>        '&#96;',
                        '\{'        =>        '&#123;',
                        '\|'        =>        '&#124;',
                        '\}'        =>        '&#125;',
                        '\~'        =>        '&#126;',
                        '\'        =>        '&#130;',
                        '\'        =>        '&#132;',
                        '\'        =>        '&#139;',
                        '\'        =>        '&#145;',
                        '\'        =>        '&#146;',
                        '\'        =>        '&#147;',
                        '\'        =>        '&#148;',
                        '\'        =>        '&#149;',
                        '\'        =>        '&#155;',
                        '\'        =>        '&#166;',
                        '\'        =>        '&#169;',
                        '\'        =>        '&#171;',
                        '\'        =>        '&#174;',
                        '\'        =>        '&#176;',
                        '\'        =>        '&#177;',
                        '\'        =>        '&#183;',
                        '\r\n'      =>        ' <br> ',
                        '\'        =>        '&#187;');
      }
      elsif ($method eq 'html' or $method == 2){
            %symbols=('\<'        =>        '&#60; ',
                        '\"'        =>        '&#34; ',
                        '\|'        =>        '&#124; ',
                        '\>'        =>        '&#62; ');
      }

      elsif ($method == 3){
            %symbols=('\<'        =>        '&#60;',
                        '\"'        =>        ' &#34; ',
                        '\|'        =>        '&#124;',
                        '\r\n'      =>        ':',
                        '\>'        =>        '&#62; ');
      }

      else {

            %symbols=('\~'   =>    ' &#126; ',
                        '\"'   =>    ' &quot; ',
                        '\''   =>    ' &#39; ',
                        '\|'   =>    '&#124;',
                        '\r\n'   =>    ' <br> ');
      }
      foreach my $item (keys(%symbols)){
            $text=~s/$item/$symbols{$item}/g;
      }
      return $text;
}

# ************************** SUB error ***********************
sub error
{
      my $f="$_[0]";
      my $l="$_[1]";

      $html_output.= qq~
            <center>
            <b>     </b>
            <br>$f<br>$l
            </center>
      ~;
      show_html_output();
      exit;
}
# ************************** SUB Selected ***********************
sub selected
{
      my($var)=@_;
      if ($var eq "yes" || $var eq "UNIX" || $var eq "top"){
            $var="";
      }
      else {
           $var="selected";
      }
      return $var;
}

# *************************** SUB checked ***********************
sub checked
{
      my $check=$_[0];

      my $ck = "checked" if $check eq "yes";

      return $ck;
}
# ****************************** SUB send_mail ********************
sub send_mail
{
      my $to=$_[0];
      my $from=$_[1];
      my $subject=$_[2];
      my $message=$_[3];
      my $mailprog=$_[4];

      $message =~ tr/\xFE\xE0\xE1\xF6\xE4\xE5\xF4\xE3\xF5\xE8-\xEF\xFF\xF0-\xF3\xE6\xE2\xFC\xFB\xE7\xF8\xFD\xF9\xF7\xFA\xDE\xC0\xC1\xD6\xC4\xC5\xD4\xC3\xD5\xC8-\xCF\xDF\xD0-\xD3\xC6\xC2\xDC\xDB\xC7\xD8\xDD\xD9\xD7\xDA/\xC0-\xFF/;

      open (SENDMAIL, "|$mailprog -t");
            print SENDMAIL "To: $to\n";
            print SENDMAIL "From: $from\n";
            print SENDMAIL "Subject: $subject\n\n";
            print SENDMAIL "$message\n";

      close (SENDMAIL);
      return;
}

# ******************************* SUB sort_by ****************************
sub sort_by
 {
      my ($unsorted,$sort_by) = @_;
      my @sorted = ();
         if ($sort_by eq "view")
         {
             @sorted = map { $_->[0] }
             reverse sort { $a->[1] <=> $b->[1] || $a->[2] <=> $b->[2]}
             map { [$_,(split /\|/)[10,9] ] } @{$unsorted};
         }
         elsif ($sort_by eq "auth")
         {
             @sorted = map { $_->[0] }
             sort { $a->[1] cmp $b->[1]}
             map { [$_,(split /\|/)[5] ] } @{$unsorted};
         }
         elsif ($sort_by eq "rate")
         {
             @sorted = map { $_->[0] }
             reverse sort { $a->[1] <=> $b->[1] || $a->[2] <=> $b->[2]}
             map { [$_,(split /\|/)[9,10] ] } @{$unsorted};
         }
         elsif ($sort_by eq "new")
         {
             @sorted = map { $_->[0] }
             reverse sort { $a->[1] <=> $b->[1] }
             map { [$_,(split /\|/)[0] ] } @{$unsorted};
         }
         elsif ($sort_by eq "old")
         {
             @sorted = map { $_->[0] }
             sort { $a->[1] <=> $b->[0] }
             map { [$_,(split /\|/)[0] ] } @{$unsorted};
         }
         elsif ($sort_by eq "az")
         {
             @sorted = map { $_->[0] }
             sort { $a->[1] cmp $b->[1] }
             map { [$_,(split /\|/)[1] ] } @{$unsorted};
         }
         elsif ($sort_by eq "za")
         {
             @sorted = map { $_->[0] }
             reverse sort { $a->[1] cmp $b->[1] }
             map { [$_,(split /\|/)[1] ] } @{$unsorted};
         }
         else
         {

            if ($sort_default eq "view")
            {
                  @sorted = map { $_->[0] }
                  reverse sort { $a->[1] <=> $b->[1] || $a->[2] <=> $b->[2]}
                  map { [$_,(split /\|/)[10,9] ] } @{$unsorted};
            }
            if ($sort_default eq "auth")
            {
                  @sorted = map { $_->[0] }
                  sort { $a->[1] cmp $b->[1]}
                  map { [$_,(split /\|/)[5] ] } @{$unsorted};
            }
            if ($sort_default eq "rate")
            {
                  @sorted = map { $_->[0] }
                  reverse sort { $a->[1] <=> $b->[1] || $a->[2] <=> $b->[2]}
                  map { [$_,(split /\|/)[9,10] ] } @{$unsorted};
            }
            if ($sort_default eq "new")
            {
                  @sorted = map { $_->[0] }
                  reverse sort { $a->[1] <=> $b->[1] }
                  map { [$_,(split /\|/)[0] ] } @{$unsorted};
            }
            if ($sort_default eq "old")
            {
                  @sorted = map { $_->[0] }
                  sort { $a->[1] <=> $b->[0] }
                  map { [$_,(split /\|/)[0] ] } @{$unsorted};
            }
            if ($sort_default eq "az")
            {
                  @sorted = map { $_->[0] }
                  sort { $a->[1] cmp $b->[1] }
                  map { [$_,(split /\|/)[1] ] } @{$unsorted};
            }
            if ($sort_default eq "za")
            {
                  @sorted = map { $_->[0] }
                  reverse sort { $a->[1] cmp $b->[1] }
                  map { [$_,(split /\|/)[1] ] } @{$unsorted};
            }
         }


     return (\@sorted);
 }

# ************************** SUB exist_file *******************************
sub exist_file
{
      my($file)=$_[0];
      unless (-e $file)
      {
            open(FILE,">$file") || die("Can't create data-file",$!);
                  close(FILE);
            chmod(0666,$file);
      }
      return;
}
# ************************** SUB exist_dir *******************************
sub exist_dir
{
      my $dir=$_[0];
      if (! -e $dir)
      {
            mkdir("$dir", 0777) || die("Cant create data - $dir ", $!);
      }
      return;
}

# *************************** SUB email_url *******************************
sub email_url
{
      my $subject=$_[0];
      my $method=$_[1];
      if ($method eq 'url'){
            if ($subject eq ''){
                  return;
            }
            else {
                  $subject="http://$subject" unless ($subject =~ /^http:\/\//);
            }
            return $subject;
      }
      elsif ($method eq 'email'){
            if ($subject !~ /\@/){
                  return $subject;
            }
            else {
                  $subject="mailto:$subject" unless ($subject =~ /^mailto:/);
            }
            return $subject;
      }
}
# ***************************** SUB random ****************************
sub random
{
      srand;
      my $dig=$_[0];
      my @chars=(0..9);
      my $random=join("",@chars[map{rand @chars}(1..$dig)]);
      return $random;

}

1;